Package org.eclipse.rdf4j.common.platform

## Interface Platform

- All Known Implementing Classes:
    `AbstractPlatform`, `DefaultPlatform`, `MacOSXPlatform`, `PlatformBase`, `PosixGnomePlatform`, `PosixKDEPlatform`, `PosixPlatform`, `WindowsPlatform`

      public interface Platform

  The Platform interface defines methods that are expected to differ slightly between operating systems, e.g. methods for opening local files, storing application data, etc.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `APPDATA_BASEDIR_PROPERTY` |
    `static String` | `OLD_DATADIR_PROPERTY` | Deprecated.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `dataDirPreserveCase()` | Check if case is preserved
    `boolean` | `dataDirReplaceColon()` | Check if colon is replaced
    `boolean` | `dataDirReplaceWhitespace()` | Check if whitespace is replaced
    `File` | `getApplicationDataDir()` | Returns the directory in which Aduna applications can store their application-dependent data, returns 'getOSApplicationDataDir' unless the system property "aduna.platform.applicationdata.dir" has been set.
    `File` | `getApplicationDataDir​(String applicationName)` | Returns the directory in which a specific application can store all its application-dependent data.
    `String` | `getName()` | Get a descriptive name for this platform.
    `File` | `getOSApplicationDataDir()` | Returns the operating system dependent application data directory.
    `File` | `getOSApplicationDataDir​(String applicationName)` | Returns the operating system dependent application data directory.
    `String` | `getRelativeApplicationDataDir​(String applicationName)` | Get the directory relative to getApplicationDataDir() for the specified application.
    `File` | `getUserHome()` | Returns the directory for the current user.

- - ### Field Detail

    - #### APPDATA_BASEDIR_PROPERTY

          static final String APPDATA_BASEDIR_PROPERTY

      See Also:
        Constant Field Values

    - #### OLD_DATADIR_PROPERTY

          @Deprecated
          static final String OLD_DATADIR_PROPERTY

      Deprecated.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getName

          String getName()

      Get a descriptive name for this platform.
      Returns:
        name of the platform

    - #### getOSApplicationDataDir

          File getOSApplicationDataDir()

      Returns the operating system dependent application data directory.
      Returns:
        application directory

    - #### getOSApplicationDataDir

          File getOSApplicationDataDir​(String applicationName)

      Returns the operating system dependent application data directory. This will be a sub-directory of the directory returned by the no-argument version of this method.
      Parameters:
        `applicationName` - name of the application
      Returns:
        application directory

    - #### getUserHome

          File getUserHome()

      Returns the directory for the current user.
      Returns:
        the current user home directory

    - #### getApplicationDataDir

          File getApplicationDataDir()

      Returns the directory in which Aduna applications can store their application-dependent data, returns 'getOSApplicationDataDir' unless the system property "aduna.platform.applicationdata.dir" has been set.
      Returns:
        the Aduna-specific application data directory

    - #### getApplicationDataDir

          File getApplicationDataDir​(String applicationName)

      Returns the directory in which a specific application can store all its application-dependent data. This will be a sub-directory of the directory returned by the no-argument version of this method. Note: the directory might not exist yet.
      Parameters:
        `applicationName` - the name of the application for which to determine the directory
      Returns:
        an application-specific data directory
      See Also:
        `getApplicationDataDir()`

    - #### getRelativeApplicationDataDir

          String getRelativeApplicationDataDir​(String applicationName)

      Get the directory relative to getApplicationDataDir() for the specified application.
      Parameters:
        `applicationName` - the name of the application
      Returns:
        the directory relative to getApplicationDataDir() for the specified application

    - #### dataDirPreserveCase

          boolean dataDirPreserveCase()

      Check if case is preserved
      Returns:
        boolean

    - #### dataDirReplaceWhitespace

          boolean dataDirReplaceWhitespace()

      Check if whitespace is replaced
      Returns:
        boolean

    - #### dataDirReplaceColon

          boolean dataDirReplaceColon()

      Check if colon is replaced
      Returns:
        boolean